#include "RaveBase/RaveInterface/rave/VacuumPropagator.h"
#include "RaveBase/Converters/interface/RaveToCmsObjects.h"
#include "RaveBase/Converters/interface/CmsToRaveObjects.h"
#include "TrackingTools/PatternTools/interface/TransverseImpactPointExtrapolator.h"
#include "RaveTools/Converters/interface/MagneticFieldSingleton.h"

// fixme need to write
#include "TrackingTools/TrajectoryState/interface/PerigeeConversions.h"

rave::Propagator * rave::VacuumPropagator::copy() const
{
  return new rave::VacuumPropagator ( * this );
}
    
rave::Track rave::VacuumPropagator::to ( const rave::Track & orig,
                          const rave::Cylinder & ) const
{
  return orig;
}

rave::Track rave::VacuumPropagator::to ( const rave::Track & orig,
                          const rave::Plane & ) const
{
  return orig;
}

rave::Track rave::VacuumPropagator::closestTo ( const rave::Track & orig,
    const rave::Point3D & pt, bool transverse ) const
{
  RaveToCmsObjects forward;
  FreeTrajectoryState fts = forward.convertTrackToFTS ( orig );
  TransverseImpactPointExtrapolator tipe( MagneticFieldSingleton::Instance() );
  GlobalPoint pos = forward.convert ( pt );
  TrajectoryStateOnSurface tsos = tipe.extrapolate( fts, pos );
  CmsToRaveObjects backward;
  rave::Track ret = backward.convert ( tsos, orig.chi2(), orig.ndof(),
     (void *) orig.id(), orig.tag() );
  return ret;
}

rave::VacuumPropagator::VacuumPropagator() {}
